#
# spec file for package openstack-dashboard
#
# Copyright (c) 2019 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%if 0%{?rhel} || 0%{?fedora}
%global rdo 1
%global http_dashboard_dir %{_datarootdir}/openstack-dashboard
%else
%global http_dashboard_dir /srv/www/openstack-dashboard
%endif
Name:           openstack-dashboard
Version:        14.0.3~dev14
Release:        1.1
Summary:        OpenStack Dashboard (Horizon)
License:        Apache-2.0
Group:          Development/Languages/Python
URL:            https://wiki.openstack.org/OpenStackDashboard
Source0:        horizon-stable-rocky.tar.gz
# https://review.openstack.org/#/c/635159/
Patch0:         0001-Do-not-set-COMPRESS_ENABLED-explicitly.patch
BuildRequires:  fdupes
BuildRequires:  gettext
BuildRequires:  openstack-macros
BuildRequires:  python-Django
BuildRequires:  python-Pint
BuildRequires:  python-XStatic
BuildRequires:  python-XStatic-Angular
BuildRequires:  python-XStatic-Angular-Bootstrap
BuildRequires:  python-XStatic-Angular-FileUpload
BuildRequires:  python-XStatic-Angular-Gettext
BuildRequires:  python-XStatic-Angular-Schema-Form
BuildRequires:  python-XStatic-Angular-lrdragndrop
BuildRequires:  python-XStatic-Bootstrap-Datepicker
BuildRequires:  python-XStatic-Bootstrap-SCSS
BuildRequires:  python-XStatic-D3
BuildRequires:  python-XStatic-Font-Awesome
BuildRequires:  python-XStatic-Hogan
BuildRequires:  python-XStatic-JQuery-Migrate
BuildRequires:  python-XStatic-JQuery.TableSorter
BuildRequires:  python-XStatic-JQuery.quicksearch
BuildRequires:  python-XStatic-JSEncrypt
BuildRequires:  python-XStatic-Jasmine
BuildRequires:  python-XStatic-Rickshaw
BuildRequires:  python-XStatic-Spin
BuildRequires:  python-XStatic-bootswatch
BuildRequires:  python-XStatic-jQuery
BuildRequires:  python-XStatic-jquery-ui
BuildRequires:  python-XStatic-mdi
BuildRequires:  python-XStatic-objectpath
BuildRequires:  python-XStatic-roboto-fontface
BuildRequires:  python-XStatic-smart-table
BuildRequires:  python-XStatic-term.js
BuildRequires:  python-XStatic-tv4
BuildRequires:  python-cinderclient
BuildRequires:  python-devel
BuildRequires:  python-django-nose
BuildRequires:  python-django-pyscss
BuildRequires:  python-django_compressor
BuildRequires:  python-glanceclient
BuildRequires:  python-heatclient
BuildRequires:  python-keystoneclient
BuildRequires:  python-mock
BuildRequires:  python-mox3
BuildRequires:  python-netaddr
BuildRequires:  python-neutronclient
BuildRequires:  python-nose
BuildRequires:  python-nose-exclude
BuildRequires:  python-nosexcover
BuildRequires:  python-novaclient
BuildRequires:  python-openstack.nose_plugin
BuildRequires:  python-oslo.concurrency
BuildRequires:  python-oslo.policy
BuildRequires:  python-pbr
BuildRequires:  python-swiftclient
BuildRequires:  python-testtools
BuildRequires:  python-troveclient
Requires:       python-horizon = %{version}-%{release}
Requires:       python-openstack_auth = %{version}-%{release}
Provides:       openstack-horizon = %{version}-%{release}
BuildArch:      noarch
%if 0%{?suse_version}
BuildRequires:  apache2
Requires:       apache2
Requires:       apache2-mod_wsgi
%endif
%if 0%{?rdo}
Requires:       httpd
Requires:       mod_wsgi
%endif
# Apache2 example configuration:
%if 0%{?rdo}
Source2:        openstack-dashboard.conf.sample.rdo
%else
Source2:        openstack-dashboard.conf.sample.suse
%endif
# To generate a self-signed certificate to be used in demo setups:
%if 0%{?suse_version}
Requires(post):  apache2-utils
%endif
%if 0%{?rdo}
Requires(post):  httpd-tools
%endif

%description
The OpenStack dashboard provides administrators and users a graphical
interface to access, provision and automate cloud-based resources. The
extensible design makes it easy to plug in and expose third party
products and services, such as billing, monitoring and additional
management tools.

The dashboard is just one way to interact with OpenStack resources.
Developers can automate access or build tools to manage their resources
using the native OpenStack API or the EC2 compatibility API.

%package -n python-horizon
Summary:        OpenStack Dashboard (Horizon) - Python Module
Group:          Development/Languages/Python
Requires:       python-Babel
Requires:       python-Django
Requires:       python-Pint
Requires:       python-PyYAML
Requires:       python-XStatic
Requires:       python-XStatic-Angular
Requires:       python-XStatic-Angular-Bootstrap
Requires:       python-XStatic-Angular-FileUpload
Requires:       python-XStatic-Angular-Gettext
Requires:       python-XStatic-Angular-Schema-Form
Requires:       python-XStatic-Angular-lrdragndrop
Requires:       python-XStatic-Bootstrap-Datepicker
Requires:       python-XStatic-Bootstrap-SCSS
Requires:       python-XStatic-D3
Requires:       python-XStatic-Font-Awesome
Requires:       python-XStatic-Hogan
Requires:       python-XStatic-JQuery-Migrate
Requires:       python-XStatic-JQuery.TableSorter
Requires:       python-XStatic-JQuery.quicksearch
Requires:       python-XStatic-JSEncrypt
Requires:       python-XStatic-Jasmine
Requires:       python-XStatic-Rickshaw
Requires:       python-XStatic-Spin
Requires:       python-XStatic-bootswatch
Requires:       python-XStatic-jQuery
Requires:       python-XStatic-jquery-ui
Requires:       python-XStatic-mdi
Requires:       python-XStatic-objectpath
Requires:       python-XStatic-roboto-fontface
Requires:       python-XStatic-smart-table
Requires:       python-XStatic-term.js
Requires:       python-XStatic-tv4
Requires:       python-cinderclient
Requires:       python-django-babel
Requires:       python-django-pyscss
Requires:       python-django_compressor
Requires:       python-futurist
Requires:       python-glanceclient
Requires:       python-heatclient
Requires:       python-httplib2
Requires:       python-iso8601
Requires:       python-keystoneclient
Requires:       python-netaddr
Requires:       python-neutronclient
Requires:       python-novaclient
Requires:       python-oslo.concurrency
Requires:       python-oslo.config
Requires:       python-oslo.i18n
Requires:       python-oslo.policy
Requires:       python-oslo.serialization
Requires:       python-oslo.utils
Requires:       python-osprofiler
Requires:       python-pbr
Requires:       python-pyScss
Requires:       python-pytz
Requires:       python-semantic_version
Requires:       python-six
Requires:       python-swiftclient

%description -n python-horizon
The Python module horizon is the core component of the OpenStack
dashboard.

%package -n python-openstack_auth
Summary:        OpenStack Auth (Horizon) - Python Module
Group:          Development/Languages/Python

%description -n python-openstack_auth
The Python module OpenStack Auth provides Authentication mechanism
for the OpenStack Dashboard (Horizon).

%prep
%autosetup -p1 -n horizon-14.0.3.dev14
%py_req_cleanup

%build
# compile mo files before build
pushd horizon
python ../manage.py compilemessages
popd
pushd openstack_dashboard
python ../manage.py compilemessages
popd
%{py2_build}

%check
rm horizon/test/unit/hacking/test_checks.py
python manage.py test horizon --settings=horizon.test.settings
# TODO
# python manage.py test openstack_dashboard --settings=openstack_dashboard.test.settings --exclude-dir=openstack_dashboard/test/integration_tests

%install
%{py2_install}

# Move openstack_dashboard files
install -d -m 755 %{buildroot}%{http_dashboard_dir}
mv %{buildroot}%{python2_sitelib}/openstack_dashboard/ %{buildroot}%{http_dashboard_dir}
install -m 755 manage.py %{buildroot}%{http_dashboard_dir}/manage.py

# Create a local_settings.py
mv %{buildroot}%{http_dashboard_dir}/openstack_dashboard/local/local_settings.py{.example,}

# create root and static files
install -m 0755 -d %{buildroot}%{http_dashboard_dir}/static
install -m 0755 -d %{buildroot}%{http_dashboard_dir}/media
pushd %{buildroot}%{http_dashboard_dir}
PYTHONPATH=%{buildroot}%{python2_sitelib} python manage.py collectstatic --noinput
popd

# cleanup after manage.py run
rm %{buildroot}%{http_dashboard_dir}/openstack_dashboard/local/local_settings.pyc
rm %{buildroot}%{http_dashboard_dir}/openstack_dashboard/local/.secret_key_store
rm %{buildroot}%{http_dashboard_dir}/openstack_dashboard/local/*secret_key_store*

# Remove duplicate files
%if 0%{?suse_version}
%fdupes %{buildroot}%{python2_sitelib}
%fdupes %{buildroot}%{http_dashboard_dir}
%endif
rm -f %{buildroot}%{http_dashboard_dir}/openstack_dashboard/.eslintrc

install -D -m 644 %{SOURCE2} %{buildroot}%{apache_conf_dir}/openstack-dashboard.conf.sample

%files
%doc README.rst
%{http_dashboard_dir}
%attr(0750, %{apache_user}, %{apache_group}) %{http_dashboard_dir}/openstack_dashboard/local
%attr(0640, %{apache_user}, %{apache_group}) %{http_dashboard_dir}/openstack_dashboard/local/__init__.py*
%config(noreplace) %attr(0640, %{apache_user}, %{apache_group}) %{http_dashboard_dir}/openstack_dashboard/local/local_settings.py*
%attr(0770, root, %{apache_group}) %{http_dashboard_dir}/static/
%attr(0770, root, %{apache_group}) %{http_dashboard_dir}/media/
%{apache_conf_dir}/openstack-dashboard.conf.sample

%files -n python-horizon
%license LICENSE
%{python2_sitelib}/horizon
%{python2_sitelib}/horizon-*.egg-info

%files -n python-openstack_auth
%license LICENSE
%{python2_sitelib}/openstack_auth

%changelog
